/*
 * 28.09.2004
 * by Andreas Grunewald
 */
package org.jd3lib;

import junit.framework.TestCase;

/**
 * @author Andreas Grunewald
 * 
 * LATER 1.0 Write Documentation
 */
public class Id3FrameListTest
        extends TestCase {

    Id3FrameCOMM comm1;

    Id3FrameCOMM comm2;

    Id3FrameList testList;

    protected void setUp() throws Exception {
        comm1 = new Id3FrameCOMM(null, null);
        comm1.setComment("Comment1");
        comm2 = new Id3FrameCOMM(null, null);
        comm2.setComment("Comment2");
        testList = new Id3FrameList();
        super.setUp();
    }

    public void testPutFrame() {

        // System.out.println(testList.size());
        testList.putFrame(comm1);
        // System.out.println(testList.size());
        testList.putFrame(comm2);
        // System.out.println(testList.size());
        Id3FrameCOMM test3 = (Id3FrameCOMM) (testList.getFrame("COMM"));
        //  System.out.println(test3);
        assertEquals(test3.getComment(), comm1.getComment());
    }

    public void testPutFrame2() {

        // System.out.println(testList.size());
        testList.putFrame(comm2);
        // System.out.println(testList.size());
        testList.putFrame(comm1);
        //  System.out.println(testList.size());
        Id3FrameCOMM test3 = (Id3FrameCOMM) (testList.getFrame("COMM"));
        // System.out.println(test3);
        assertEquals(test3.getComment(), comm2.getComment());
    }

    public void testGetFrameCount() {
        assertNull(testList.getFrame(comm1.getFrameID()));
        testList.putFrame(comm2);
        testList.putFrame(comm1);
        assertEquals(testList.getFrameCount(comm1.getFrameID()), 2);
    }

    public void testGetFrame() {
        assertNull(testList.getFrame(comm1.getFrameID()));
        //assertEquals(testList.getFrameCount(comm1.getFrameID()),2);
    }

    public void testToString() {
        testList.putFrame(comm1);
        Id3FrameTIT2 tit = new Id3FrameTIT2(null, null);
        tit.setTitle("Titel");
        testList.putFrame(tit);
        Id3FrameTPE1 tpe = new Id3FrameTPE1(null, null);
        tpe.setInformation("Artist");
        testList.putFrame(tpe);
        System.out.println(testList);
    }

    public void testGetMultiFrame() {
        assertNull(testList.getMultiFrame(comm1.getFrameID(), 0));
        assertNull(testList.getMultiFrame(comm1.getFrameID(), 1));
        testList.putFrame(comm1);
        assertNull(testList.getMultiFrame(comm1.getFrameID(), 1));
        assertEquals(testList.getMultiFrame(comm1.getFrameID(), 0).toString(),
                comm1.toString());

        //assertEquals(testList.getFrameCount(comm1.getFrameID()),2);
    }

}