/*
 * $Id: Id3FramePCNT.java,v 1.8 2005/04/27 08:41:00 gruni Exp $
 * $Author: gruni $ 
 * 
 * $Log: Id3FramePCNT.java,v $
 * Revision 1.8  2005/04/27 08:41:00  gruni
 * changes due to refactoring
 *
 */
package org.jd3lib;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.nio.ByteBuffer;

import org.jd3lib.util.DebugOut;

/**
 * 4.17. Play counter
 * 
 * This is simply a counter of the number of times a file has been played. The
 * value is increased by one every time the file begins to play. There may only
 * be one "PCNT" frame in each tag. When the counter reaches all one's, one byte
 * is inserted in front of the counter thus making the counter eight bits
 * bigger. The counter must be at least 32-bits long to begin with.
 * 
 * <Header for 'Play counter', ID: "PCNT">
 * 
 * Counter $xx xx xx xx (xx ...)
 * 
 * @author Andreas Grunewald
 *  
 */
public class Id3FramePCNT
    extends Id3Frame {

  /**
   * @param frameData
   * @param header
   */
  public Id3FramePCNT(ByteBuffer frameData, Id3v2FrameHeader header) {
    super(frameData, header);
    // LATER 0.7 Auto-generated constructor stub
  }

  int count;

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#initialize(java.io.InputStream,
   *      org.jd3lib.Id3v2FrameHeader)
   */
  protected void initializeExisting(InputStream tagData,
      Id3v2FrameHeader header2) {
    DebugOut.println("RunningPCNT initialize");
    byte[] temp = new byte[header2.getSize()];
    try {
      tagData.read(temp);
    } catch (IOException e) {
      //LATER 1.5 Auto-generated catch block
      e.printStackTrace();
    }
    //TODO Load data from Temp Array into fields
    //data = new FrameData(temp);

  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#getDataString()
   */
  protected String getFrameString() {
    return "Playcount:" + count;
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#initializeNew(org.jd3lib.Id3v2FrameHeader)
   */
  protected void initializeNew(Id3v2FrameHeader header) {
    // LATER 0.1 Auto generated method stub

  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#getFrameData()
   */
  protected ByteArrayOutputStream getFrameData() {
    // FIXME return correct getFrameData
    return new ByteArrayOutputStream();
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#initializeExisting(java.nio.ByteBuffer,
   *      org.jd3lib.Id3v2FrameHeader)
   */
  protected void initializeExisting(ByteBuffer frameData,
      Id3v2FrameHeader header) {
    // LATER 0.1 Auto generated method stub

  }

}