/*
 * 29.08.2004 by Andreas Grunewald
 */
package org.jd3lib;

import java.nio.ByteBuffer;

/**
 * TENC The 'Encoded by' frame contains the name of the person or organisation
 * that encoded the audio file. This field may contain a copyright message, if
 * the audio file also is copyrighted by the encoder.
 * 
 * @author Andreas Grunewald
 * 
 * LATER 1.0 Write Documentation
 */
public class Id3FrameTENC
    extends Id3FrameTBase {

  /**
   * @param frameData
   * @param header
   */
  public Id3FrameTENC(ByteBuffer frameData, Id3v2FrameHeader header) {
    super(frameData, header);
    // LATER 0.7 Auto-generated constructor stub
  }

  /**
   * Special default Flags
   * 
   * 3. Preserved if tag is altered, discarded if file is altered.
   * 
   * ETCO, EQUA, MLLT, POSS, SYLT, SYTC, RVAD, TENC, TLEN, TSIZ
   */
  public byte[] getDefaultFlags() {
    return new byte[] { 0x40, 0x00 };
  }
}