/*
 * 29.08.2004 by Andreas Grunewald
 */
package org.jd3lib;

import java.nio.ByteBuffer;

/**
 * TRCK
 * 
 * The 'Track number/Position in set' frame is a numeric string containing the
 * order number of the audio-file on its original recording. This may be
 * extended with a "/" character and a numeric string containing the total numer
 * of tracks/elements on the original recording. E.g. "4/9".
 * 
 * @author Andreas Grunewald
 *  
 */
public class Id3FrameTRCK
    extends Id3FrameTBase {

  /**
   * @param frameData
   * @param header
   */
  public Id3FrameTRCK(ByteBuffer frameData, Id3v2FrameHeader header) {
    super(frameData, header);
    // LATER 0.7 Auto-generated constructor stub
  }

  public int getTrackNo() throws NumberFormatException {
    return new Integer(getInformation()).intValue();
  }

  public void setTrackNo(int no) {
    setInformation(new Integer(no).toString());
  }

}