/*
 * $Id: Id3FrameTXXX.java,v 1.8 2005/04/27 08:43:07 gruni Exp $
 * $Author: gruni $ 
 * 
 * $Log: Id3FrameTXXX.java,v $
 * Revision 1.8  2005/04/27 08:43:07  gruni
 * changes due to refactoring
 *
 */
package org.jd3lib;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.nio.ByteBuffer;

import org.jd3lib.util.DebugOut;

/**
 * 4.2.2. User defined text information frame
 * 
 * This frame is intended for one-string text information concerning the
 * audiofile in a similar way to the other "T"-frames. The frame body consists
 * of a description of the string, represented as a terminated string, followed
 * by the actual string. There may be more than one "TXXX" frame in each tag,
 * but only one with the same description.
 * 
 * <Header for 'User defined text information frame', ID: "TXXX">
 * 
 * Text encoding $xx
 * 
 * Description <text string according to encoding> $00 (00)
 * 
 * Value <text string according to encoding>
 * 
 * @author Andreas Grunewald
 *  
 */
public class Id3FrameTXXX
    extends Id3FrameMultiple {

  /**
   * @param frameData
   * @param header
   */
  public Id3FrameTXXX(ByteBuffer frameData, Id3v2FrameHeader header) {
    super(frameData, header);
    // Later 0.7 Auto-generated constructor stub
  }

  /**
   * 
   * @deprecated Dont use Streams anymore use ByteBuffers and java.nio
   * @see org.jd3lib.Id3Frame#initialize(java.io.InputStream,
   *      org.jd3lib.Id3v2FrameHeader)
   */
  protected void initializeExisting(InputStream tagData,
      Id3v2FrameHeader header2) {
    DebugOut.println("RunningTXXX initialize");
    byte[] temp = new byte[header2.getSize()];
    try {
      tagData.read(temp);
    } catch (IOException e) {
      //LATER 4.0 Auto-generated catch block
      e.printStackTrace();
    }
    //TODO 4.0 Load data from Temp Array into fields
    //data = new FrameData(temp);

  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#getDataString()
   */
  protected String getFrameString() {
    // LATER 0.1 Auto generated method stub
    return null;
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#initializeNew(org.jd3lib.Id3v2FrameHeader)
   */
  protected void initializeNew(Id3v2FrameHeader header) {
    // LATER 0.1 Auto generated method stub

  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#getFrameData()
   */
  protected ByteArrayOutputStream getFrameData() {
    // LATER 0.1 Auto generated method stub
    return null;
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3FrameMultiple#isDifferent(org.jd3lib.Id3FrameMultiple)
   */
  public boolean isDifferent(Id3FrameMultiple toCompare) {
    // LATER 0.1 Auto generated method stub
    return false;
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#initializeExisting(java.nio.ByteBuffer,
   *      org.jd3lib.Id3v2FrameHeader)
   */
  protected void initializeExisting(ByteBuffer frameData,
      Id3v2FrameHeader header) {
    // LATER 0.1 Auto generated method stub

  }

}