/*
 * $Id: Id3FrameUSLT.java,v 1.6 2005/04/27 08:45:58 gruni Exp $
 * $Author: gruni $ 
 * 
 * $Log: Id3FrameUSLT.java,v $
 * Revision 1.6  2005/04/27 08:45:58  gruni
 * changes due to refactoring
 *
 */
package org.jd3lib;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.nio.ByteBuffer;

import org.jd3lib.util.DebugOut;

/**
 * Unsychronised lyrics/text transcription
 * 
 * This frame contains the lyrics of the song or a text transcription of other
 * vocal activities. The head includes an encoding descriptor and a content
 * descriptor. The body consists of the actual text. The 'Content descriptor' is
 * a terminated string. If no descriptor is entered, 'Content descriptor' is $00
 * (00) only. Newline characters are allowed in the text. There may be more than
 * one 'Unsynchronised lyrics/text transcription' frame in each tag, but only
 * one with the same language and content descriptor.
 * 
 * <Header for 'Unsynchronised lyrics/text transcription', ID: "USLT">
 * 
 * Text encoding $xx
 * 
 * Language $xx xx xx
 * 
 * Content descriptor <text string according to encoding> $00 (00)
 * 
 * Lyrics/text <full text string according to encoding>
 * 
 * 
 * @author Andreas Grunewald
 *  
 */
public class Id3FrameUSLT
    extends Id3FrameMultiple {

  /**
   * @param frameData
   * @param header
   */
  public Id3FrameUSLT(ByteBuffer frameData, Id3v2FrameHeader header) {
    super(frameData, header);
    // LATER 0.7 Auto-generated constructor stub
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#initializeNew(org.jd3lib.Id3v2FrameHeader)
   */
  protected void initializeNew(Id3v2FrameHeader header) {
    // LATER 0.1 Auto generated method stub

  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#initializeExisting(java.io.InputStream,
   *      org.jd3lib.Id3v2FrameHeader)
   */
  protected void initializeExisting(InputStream tagData,
      Id3v2FrameHeader header2) {
    DebugOut.println("RunningUSLT initialize");
    byte[] temp = new byte[header2.getSize()];
    try {
      tagData.read(temp);
    } catch (IOException e) {
      //LATER 1.5 Auto-generated catch block
      e.printStackTrace();
    }

  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#getDataString()
   */
  protected String getFrameString() {
    // LATER 0.1 Auto generated method stub
    return null;
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#getFrameData()
   */
  protected ByteArrayOutputStream getFrameData() {
    // LATER 0.1 Auto generated method stub
    return new ByteArrayOutputStream(0);
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3FrameMultiple#isDifferent(org.jd3lib.Id3FrameMultiple)
   */
  public boolean isDifferent(Id3FrameMultiple toCompare) {
    // LATER 0.1 Auto generated method stub
    return false;
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#initializeExisting(java.nio.ByteBuffer,
   *      org.jd3lib.Id3v2FrameHeader)
   */
  protected void initializeExisting(ByteBuffer frameData,
      Id3v2FrameHeader header) {
    DebugOut.println("RunningUSLT initialize");
    //DONEXT implement reading of USLT

  }

}