/*
 * $Id: Id3FrameUnknown.java,v 1.4 2005/04/27 08:44:39 gruni Exp $
 * $Author: gruni $ 
 * 
 * $Log: Id3FrameUnknown.java,v $
 * Revision 1.4  2005/04/27 08:44:39  gruni
 * changes due to refactoring
 *
 */
package org.jd3lib;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.nio.ByteBuffer;

import org.jd3lib.util.DebugOut;

/**
 * @author Andreas Grunewald
 * 
 * LATER 1.0 Write Documentation
 */
public class Id3FrameUnknown
    extends Id3Frame {

  //byte[] rawData;
  ByteBuffer rawDataBuf;

  /**
   * @param frame
   * @param head
   */
  public Id3FrameUnknown(ByteBuffer frame, Id3v2FrameHeader head) {
    super(frame, head);
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#initializeNew(org.jd3lib.Id3v2FrameHeader)
   */
  protected void initializeNew(Id3v2FrameHeader header) {
    rawDataBuf = null;
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#initializeExisting(java.nio.ByteBuffer,
   *      org.jd3lib.Id3v2FrameHeader)
   */
  protected void initializeExisting(ByteBuffer frameData,
      Id3v2FrameHeader header) {
    rawDataBuf = frameData;
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#initializeExisting(java.io.InputStream,
   *      org.jd3lib.Id3v2FrameHeader)
   */
  protected void initializeExisting(InputStream tagData,
      Id3v2FrameHeader header2) {
    DebugOut.println("RunningUnknownFrame initialize");
    byte[] rawData = new byte[header2.getSize()];
    try {
      tagData.read(rawData);
    } catch (IOException e) {
      e.printStackTrace();
    }
    rawDataBuf = ByteBuffer.wrap(rawData);
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#getDataString()
   */
  protected String getFrameString() {
    String out = "";
    char[] outChar = rawDataBuf.asCharBuffer().array();
    for (int i = 0; i < outChar.length; i++) {
      out += "<0x" + Integer.toHexString(outChar[i]) + ":" + outChar[i] + ">";
    }
    return out;
  }

  /*
   * (non-Javadoc)
   * 
   * @see org.jd3lib.Id3Frame#getFrameData()
   */
  protected ByteArrayOutputStream getFrameData() {
    ByteArrayOutputStream out = new ByteArrayOutputStream();
    try {
      out.write(rawDataBuf.array());
    } catch (IOException e) {
      e.printStackTrace();
    }
    return out;
  }

}