/*
 * $Id: Wamp.java,v 1.2 2005/01/27 17:27:15 gruni Exp $
 * $Author: gruni $ 
 * $Revision: 1.2 $
 * $Date: 2005/01/27 17:27:15 $
 * $Log: Wamp.java,v $
 * Revision 1.2  2005/01/27 17:27:15  gruni
 * updated
 *
 * Revision 1.8  2004/12/16 16:59:52  gruni
 * a lot of updates switching to NIO and adding ID3v1
 */
package org.jd3lib.adapter;

import org.jd3lib.Id3v1Tag;
import org.jd3lib.MP3File;

/**
 * @author Andreas Grunewald
 * 
 * LATER 1.0 Write Documentation
 */

public class Wamp {

	private boolean v1dirty = false;

	private boolean v2dirty = false;

	public WampMpegInfo mpegInfo = null;

	public MP3File theMP3;

	public Id3v1Tag v1 = null;

	public WampID3v2 v2 = null;

	/**
	 * @param theFile
	 */
	public Wamp(MP3File theFile) {
		theMP3 = theFile;
		if (theFile.hasID3v1())
			v1 = theFile.getID3v1();
		if (theFile.hasID3v2())
			v2 = new WampID3v2(theFile.getID3v2());
		if (theFile.hasMPEGInfo())
			mpegInfo = new WampMpegInfo(theFile.getMEPGInfo());
	}

	/**
	 *  
	 */
	public void copyFromId3v1() {
		//FIXME 0.5 implement

	}

	/**
	 *  
	 */
	public void copyToId3v1() {
		//FIXME 0.5 implement

	}

	/**
	 *  
	 */
	public void disableID3v1Tag() {
		v1dirty = true;
	}

	/**
	 *  
	 */
	public void disableID3v2Tag() {
		v2dirty = true;

	}

	/**
	 *  
	 */
	public void enableID3v1Tag() {
		v1 = new Id3v1Tag();
		v1dirty = false;
	}

	/**
	 *  
	 */
	public void enableID3v2Tag() {
		v2 = new WampID3v2();
		v2dirty = false;
	}
    
    public void setEnableID3v2Tag(boolean active){
       if (active) enableID3v2Tag();
       else disableID3v2Tag();
    }

	/**
	 * actives ID3v1Tag true deactives ID3v1Tag false
	 */
	public void setID3v1TagActive(boolean active) {
		v1dirty = !active;
	}

	/**
	 *  
	 */
	public void update() {
		if (v1dirty)
			v1 = null;
		if (v2dirty)
			v2 = null;
		else if (v2 != null) {
            theMP3.writeToDisk(null);
		}

	}

}