/*
 * $Id: ArcAudioFileDecorator.java,v 1.3 2005/04/27 08:06:26 gruni Exp $
 * $Author: gruni $ 
 * $Revision: 1.3 $
 * $Date: 2005/04/27 08:06:26 $
 * $Log: ArcAudioFileDecorator.java,v $
 * Revision 1.3  2005/04/27 08:06:26  gruni
 * only codestyle cleaning
 *
 * Revision 1.2  2005/03/02 08:10:49  gruni
 * a lot of structural refactoring
 *
 * Revision 1.1  2005/02/27 01:46:09  gruni
 * Decorator for AudioFiles with extrefunctionality needed by the ArcLib
 *
 */
package org.jd3lib.archoslib;

import java.io.File;

import org.jd3lib.AudioFile;
import org.jd3lib.MetaData;
import org.jd3lib.NoEmptyMetaData;
import org.jd3lib.archoslib.lists.ArcEntry;

/**
 * Decorator for AudioFile that adds nonempty Metadata
 * @author Andreas Grunewald
 *
 * TODO Document
 */
public class ArcAudioFileDecorator implements AudioFile, ArcEntry {

  private AudioFile component;

  private short number;

  /**
   * @param file
   */
  public ArcAudioFileDecorator(AudioFile file) {
    component = file;
  }

  /* (non-Javadoc)
   * @see org.jd3lib.AudioFile#getMetaData()
   */
  public MetaData getMetaData() {
    if (component.getMetaData() != null)
        return new NoEmptyMetaData(component.getMetaData());
    return null;
  }

  /* (non-Javadoc)
   * @see org.jd3lib.AudioFile#getTheFile()
   */
  public File getTheFile() {
    return component.getTheFile();
  }

  /* (non-Javadoc)
   * @see org.jd3lib.AudioFile#getFileName()
   */
  public String getFileName() {
    return component.getFileName();
  }

  /* (non-Javadoc)
   * @see org.jd3lib.AudioFile#getFileType()
   */
  public String getFileType() {
    return component.getFileType();
  }

  /* (non-Javadoc)
   * @see java.lang.Comparable#compareTo(java.lang.Object)
   */
  public int compareTo(Object o) {
    if (o instanceof ArcAudioFileDecorator) {
      return this.getMetaData().getTitle().compareTo(
          ((ArcAudioFileDecorator) o).getMetaData().getTitle());
    }
    throw new ClassCastException("Can not compare these to types");
  }

  public String toString() {
    return this.getMetaData().getTitle();
  }

  /* (non-Javadoc)
   * @see org.jd3lib.archoslib.lists.ArcEntry#getNumber()
   */
  public short getNumber() {
    return number;
  }

  public void setNumber(short num) {
    number = num;
  }

}