/*
 * $Id: ListOfAlbums.java,v 1.2 2005/03/02 08:10:03 gruni Exp $
 * $Author: gruni $ 
 * $Revision: 1.2 $
 * $Date: 2005/03/02 08:10:03 $
 * $Log: ListOfAlbums.java,v $
 * Revision 1.2  2005/03/02 08:10:03  gruni
 * structural refactoring made some stuff just better no new functions
 *
 * Revision 1.1  2005/02/27 01:42:36  gruni
 * The New Structure of Lists
 *
 */
package org.jd3lib.archoslib.lists;

import java.util.Hashtable;

import org.jd3lib.archoslib.ArcAudioFileDecorator;


/**
 * @author Andreas Grunewald
 *
 * TODO v0.7 Document
 */
public class ListOfAlbums extends List {

  private Hashtable found;
  
  /**
   * @param root
   * @param artist
   */
  public ListOfAlbums(String defName, List defParent) {
    super(defName,LIST_ALBUM,defParent);
    found = new Hashtable();  
  }

  /* (non-Javadoc)
   * @see org.jd3lib.archoslib.lists.List#accept(java.lang.Object)
   */
  protected boolean accept(ArcEntry e) {
    if (e instanceof ListOfSong) return true;
    return false;
  }

  /* (non-Javadoc)
   * @see org.jd3lib.archoslib.lists.List#process(org.jd3lib.AudioFile)
   */
  public void process(ArcAudioFileDecorator data) {
   
    ListOfSong current;
    if (!(found.containsKey(data.getMetaData().getAlbum()))){
      //add new Artist to List and select as current
      found.put(data.getMetaData().getAlbum(),new ListOfSong(data.getMetaData().getAlbum(),ListOfSong.SORT_BY_TRACK, this));
      current = (ListOfSong) found.get(data.getMetaData().getAlbum());
      this.add(current);
    } else {
      //Select existing Artist
      current = (ListOfSong) found.get(data.getMetaData().getAlbum());
    }
    current.process(data);
    this.sort(true);
  }

}
