/*
 * $Id: Queue.java,v 1.5 2005/03/14 15:58:50 gruni Exp $
 * $Author: gruni $ 
 * $Revision: 1.5 $
 * $Date: 2005/03/14 15:58:50 $
 * $Log: Queue.java,v $
 * Revision 1.5  2005/03/14 15:58:50  gruni
 * *** empty log message ***
 *
 * Revision 1.4  2005/02/27 01:41:35  gruni
 * extened Queue functionallity
 *
 * Revision 1.3  2005/01/27 17:12:57  gruni
 * updated
 *
 */
package org.jd3lib.compatible;

import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;

/**
 * Backward compatible implementation of a queue until JDK 1.5 is available for
 * all systems including MacOS X
 * @author Grunewald
 * @version 1.0
 */
public class Queue /*implements Queue*/{
    //LATER 5.0 Rename Class to really implement Queue
    /**
     * The list holding the queued elements
     */
    private LinkedList myQueue;
    
    /**
     * The constructur creating an empty Queue with a LinkedList.
     */
    public Queue(){
      myQueue = new LinkedList();    
    }

    /**
     * Removes the first element from the queue and returns it. 
     * @return the first element in the queue
     */
    public Object remove() {
        return myQueue.removeFirst();
    }

    
    /**
     * @return wether or not the Queue is Empty
     */
    public boolean isEmpty() {
        return myQueue.isEmpty();
    }


    /**
     * Returns an Iterator of the elements in the Queue. 
     * @return Iterator ofer the queue
     */
    public Iterator iterator() {          
        return myQueue.iterator();
    }

    /**
     * Adds the given Object to the Queue. It is put at the end so that a FIFO
     * order is achieved. 
     * @param newElement the Object to be added
     * @return true when the Object has been added
     */
    public boolean add(Object newElement) {
       return myQueue.add(newElement);
    }
    
    /**
     * Adds all Elements of the given Collection to the queue
     * TODO v1.0 document more
     * */
    public boolean addAll(Collection newElements){
       Iterator ite = newElements.iterator();
       while(ite.hasNext()){
         this.add(ite.next());
       }         
       return false;
    }
    
    
    
    /**
     * @return the size of this queue.
     * */
    public int size(){
      return myQueue.size();
    }


}
