/*
 * 12.10.2004
 * by Andreas Grunewald
 */
package org.jd3lib.gui;

import info.clearthought.layout.TableLayout;

import java.awt.BorderLayout;
import java.awt.LayoutManager;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ScrollPaneConstants;

import org.jd3lib.adapter.WampID3v2;

/**
 * @author Andreas Grunewald
 * 
 * LATER 1.0 Write Documentation
 */
public class ID3v2Info extends JPanel {

	/*
	 * TODO create minimum size where it can't get smaller
	 */

	JCheckBox checkID3v2 = new JCheckBox("ID3v2 Tag");

	JTextField textTitle;

	JTextField textTrck;

	JTextField textArtist;

	JTextField textAlbum;

	JTextField textYear;

	JTextField textGenre;
	JTextArea textComment;
	JTextField textComposer;
	JTextField textOrgArtist;
	JTextField textCopyright;
	JTextField textUrl;
	JTextField textEncoded;

	/**
	 *  
	 */
	public ID3v2Info() {
		super();
		checkID3v2.setSelected(false);
		if (checkID3v2.isSelected() == false) {
			this.setEnabled(false);
		}
		{
			textTitle = new JTextField();
			textTrck = new JTextField();
			textArtist = new JTextField();
			textAlbum = new JTextField();
			textYear = new JTextField();
			textGenre = new JTextField();
            textComment = new JTextArea();
     		textComposer = new JTextField();
			textOrgArtist = new JTextField();
			textCopyright = new JTextField();
			textUrl = new JTextField();
			textEncoded = new JTextField();
		}
		standardInit();
	}

	/**
	 * @param v2
	 */
	public ID3v2Info(WampID3v2 v2) {
		super();
		checkID3v2.setSelected(true);
		
		textTrck = new JTextField("" + v2.getTrack(), 3);
		textTitle = new JTextField(v2.getTitle());
		textArtist = new JTextField(v2.getArtist());
		textAlbum = new JTextField(v2.getAlbum());
		textYear = new JTextField("" + v2.getYear());
		textGenre = new JTextField(v2.getGenre());
		textComment = new JTextArea(v2.getComment());
        textComposer = new JTextField(v2.getComposer());
		textOrgArtist = new JTextField(v2.getOrigArtist());
		textCopyright = new JTextField(v2.getCopyright());
		textUrl = new JTextField(v2.getURL());
		textEncoded = new JTextField(v2.getEncodedBy());
		
		standardInit();
	}

	private void standardInit() {
		setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEtchedBorder(), "ID3v2"));
		populateMainPanel();
	}

	private void populateMainPanel() {
		double[][] size = {
				{ -2.0, -2.0, -2.0, -1.0 },
				{ -2.0, -2.0, -2.0, -2.0, -2.0, -1.0, -2.0, -2.0, -2.0, -2.0,
						-2.0, 0.3, -2.0 } };
		LayoutManager layout = new TableLayout(size);
		setLayout(layout);

		add(checkID3v2, "1, 0, l, c");

		JPanel panelTrack = createPanelTrck();
		add(panelTrack, "3, 0, r, f");

		JLabel labelTitle = new JLabel("Title");
		add(labelTitle, "0, 1, r, t");
		add(textTitle, "1, 1, 3, 1");

		JLabel labelArtist = new JLabel("Artist");
		add(labelArtist, "0, 2, r, t");
		add(textArtist, "1, 2, 3, 2");

		JLabel labelAlbum = new JLabel("Album");
		add(labelAlbum, "0, 3, r, t");
		add(textAlbum, "1, 3, 3, 3");

		JLabel labelYear = new JLabel("Year");
		add(labelYear, "0, 4, r, t");
		add(textYear, "1, 4, l, c");

		JLabel labelGenre = new JLabel("Genre");
		add(labelGenre, "2, 4, r, f");
		add(textGenre, "3, 4, f, f");

		JLabel labelComment = new JLabel("Comment");
		add(labelComment, "0, 5, r, t");
        JScrollPane scrollPaneComment = 
            new JScrollPane(textComment,
                            ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
                            ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        textComment.setLineWrap(true);
        textComment.setFont(textComposer.getFont());
		add(scrollPaneComment, "1, 5, 3, 5");

		JLabel labelComposer = new JLabel("Composer");
		add(labelComposer, "0, 6, r, t");
		add(textComposer, "1, 6, 3, 6");

		JLabel labelOrgArtist = new JLabel("Orig. Artist");
		add(labelOrgArtist, "0, 7, r, t");
		add(textOrgArtist, "1, 7, 3, 7");

		JLabel labelCopyright = new JLabel("Copyright");
		add(labelCopyright, "0, 8, r, t");
		add(textCopyright, "1, 8, 3, 8");

		JLabel labelUrl = new JLabel("URL");
		add(labelUrl, "0, 9, r, t");
		add(textUrl, "1, 9, 3, 9");

		JLabel labelEncoden = new JLabel("Encoded by");
		add(labelEncoden, "0, 10, r, t");
		add(textEncoded, "1, 10, 3, 10");

		JPanel panelButtons = createPanelButtons();
		add(panelButtons, "0, 12, 3, 12");

	}

	/**
	 * @return
	 */
	private JPanel createPanelTrck() {
		JPanel panel = new JPanel(new BorderLayout());
		JLabel labelTrack = new JLabel("Track #");
		panel.add(labelTrack, BorderLayout.LINE_START);
		panel.add(textTrck, BorderLayout.LINE_END);
		return panel;
	}

	private JPanel createPanelButtons() {
		double[][] size = { { -2.0, -2.0, -1.0 }, { -2.0 } };
		LayoutManager layout = new TableLayout(size);
		JPanel panel = new JPanel(layout);

		JButton buttonCopyFrom = new JButton("Copy from ID3v1");
		panel.add(buttonCopyFrom, "1, 0, f, f");

		JButton buttonCopyTo = new JButton("Copy to ID3v1");
		panel.add(buttonCopyTo, "0, 0, f, f");

		return panel;
	}
}