/*
 * 12.10.2004 by Andreas Grunewald
 */
package org.jd3lib.gui;

import info.clearthought.layout.TableLayout;
import info.clearthought.layout.TableLayoutConstants;

import java.awt.BorderLayout;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.UIManager;

import org.jd3lib.MP3File;
import org.jd3lib.adapter.Wamp;

/**
 * @author Andreas Grunewald
 * 
 * LATER 1.0 Write Documentation
 */
public class WinampFileInfo extends JPanel {

    private static JFrame frame;

    private JButton cancelButton;

    private MPEGInfo mpegInfo;

    private JTextField theFilename;

    Wamp theWampModel;

    private JButton undoButton;

    private JButton updateButton;

    private ID3v1Info v1Info;

    private ID3v2Info v2Info;

    /**
     * @param theFile
     */
    public WinampFileInfo(MP3File theFile) {
        super();
        theWampModel = new Wamp(theFile);
        theFilename = new JTextField(theFile.getFilePath());
        v1Info = new ID3v1Info(theWampModel.v1);
        v2Info = new ID3v2Info(theWampModel.v2);
        mpegInfo = new MPEGInfo(theWampModel.mpegInfo);
        populateMainPanel();
    }

    public static void main(String args[]) {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            e.printStackTrace();
        }
        MP3File theFile = new MP3File("test_data/winampfileinfo/TestMP3.mp3");
        System.out.println(theFile.getID3v2().getFrame("TIT2"));
        WinampFileInfo wFIo = new WinampFileInfo(theFile);
        System.out.println(theFile.getID3v2().getFrame("TIT2"));

        frame = new JFrame("MPEG file info box + ID3 tag editor");
        frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(e.getID());
            }
        });

        frame.getContentPane().add(wFIo, BorderLayout.CENTER);
        frame.pack();
        frame.setVisible(true);
    }

    private void populateMainPanel() {

        double[][] size = {
                { TableLayoutConstants.FILL, TableLayoutConstants.FILL },
                { TableLayoutConstants.PREFERRED, TableLayoutConstants.FILL,
                        TableLayoutConstants.FILL,
                        TableLayoutConstants.PREFERRED } };
        LayoutManager layout = new TableLayout(size);
        setLayout(layout);
        theFilename.setEditable(false);
        JPanel buttonPan = new JPanel();
        updateButton = new JButton("Update");
        updateButton.addActionListener(new ActionListener() {
            /*
             * (non-Javadoc)
             * 
             * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
             */
            public void actionPerformed(ActionEvent arg0) {
                theWampModel.update();

            }
        });
        cancelButton = new JButton("Cancel");
        undoButton = new JButton("Undo Changes");
        double[][] butPane = {
                { TableLayoutConstants.PREFERRED,
                        TableLayoutConstants.PREFERRED,
                        TableLayoutConstants.FILL,
                        TableLayoutConstants.PREFERRED },
                { TableLayoutConstants.FILL } };
        buttonPan.setLayout(new TableLayout(butPane));
        buttonPan.add(updateButton, "0,0,f,f");
        buttonPan.add(cancelButton, "1,0,f,f");
        buttonPan.add(undoButton, "3,0,f,f");

        add(theFilename, "0, 0, 1, 0");
        add(v1Info, "0, 1, f, f");
        add(mpegInfo, "0, 2, f, f");
        add(v2Info, "1, 1, 1, 3");
        add(buttonPan, "0,3,f,f");

    }

}