package org.jd3lib.util;

/*
 * A 1.4 application that demonstrates using spinners. Other files required:
 * SpringUtilities.java
 */

import java.awt.Container;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerModel;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class Numba extends JPanel {
    public Numba() {

        final JSpinner spinner = addLabeledSpinner(this, "Int",
                new SpinnerNumberModel(15, 0, 255, 1));

        JLabel byteLabel = new JLabel("Byte");
        add(byteLabel);
        final JTextField byteText = new JTextField(2);

        add(byteText);
        JLabel bitLabel = new JLabel("Bit");
        add(bitLabel);
        final JTextField bitText = new JTextField(8);

        add(bitText);

        spinner.addChangeListener(new ChangeListener() {
            public void stateChanged(ChangeEvent arg0) {
                arg0.toString();//To avoid warning
                int number = ((Integer) spinner.getValue()).intValue();
                String out = Integer.toHexString(number);
                if (out.length() < 2)
                    out = "0" + out;
                byteText.setText(out);
                out = Integer.toBinaryString(((Integer) spinner.getValue())
                        .intValue());
                if (out.length() < 8) {
                    String add = "";
                    for (int i = 0; i < 8 - out.length(); i++) {
                        add += "0";
                    }
                    out = add + out;
                }
                bitText.setText(out);
            }
        });

    }

    static protected JSpinner addLabeledSpinner(Container c, String label,
            SpinnerModel model) {
        JLabel l = new JLabel(label);
        c.add(l);

        JSpinner spinner = new JSpinner(model);
        l.setLabelFor(spinner);
        c.add(spinner);
        return spinner;
    }

    /**
     * Create the GUI and show it. For thread safety, this method should be
     * invoked from the event-dispatching thread.
     */
    static void createAndShowGUI() {
        //Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);

        //Create and set up the window.
        JFrame frame = new JFrame("NumbaNumba");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Create and set up the content pane.
        JComponent newContentPane = new Numba();
        newContentPane.setOpaque(true); //content panes must be opaque
        frame.setContentPane(newContentPane);

        //Display the window.
        frame.pack();
        frame.setVisible(true);
    }

    public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });
    }
}

